' Fig. 8.6: CTime3.vb
' Represents time in 24-hour format and contains properties.

Class CTime3
   Inherits Object

   ' declare Integers for hour, minute and second
   Private mHour As Integer
   Private mMinute As Integer
   Private mSecond As Integer

   ' CTime3 constructor: initialize each instance variable to zero
   ' and ensure that each CTime3 object starts in consistent state
   Public Sub New()
      SetTime(0, 0, 0)
   End Sub ' New

   ' CTime3 constructor: 
   ' hour supplied, minute and second defaulted to 0
   Public Sub New(ByVal hourValue As Integer)
      SetTime(hourValue, 0, 0)
   End Sub ' New

   ' CTime3 constructor: 
   ' hour and minute supplied; second defaulted to 0
   Public Sub New(ByVal hourValue As Integer, _
      ByVal minuteValue As Integer)

      SetTime(hourValue, minuteValue, 0)
   End Sub ' New

   ' CTime3 constructor: hour, minute and second supplied
   Public Sub New(ByVal hourValue As Integer, _
      ByVal minuteValue As Integer, ByVal secondValue As Integer)

      SetTime(hourValue, minuteValue, secondValue)
   End Sub ' New

   ' CTime3 constructor: another CTime3 object supplied
   Public Sub New(ByVal timeValue As CTime3)
      SetTime(timeValue.mHour, timeValue.mMinute, _
         timeValue.mSecond)
   End Sub ' New

   ' set new time value using universal time;
   ' uses properties to perform validity checks on data
   Public Sub SetTime(ByVal hourValue As Integer, _
      ByVal minuteValue As Integer, ByVal secondValue As Integer)

      Hour = hourValue     ' looks
      Minute = minuteValue ' dangerous
      Second = secondValue ' but it is correct
   End Sub ' SetTime

   ' property Hour
   Public Property Hour() As Integer

      ' return mHour value
      Get
         Return mHour
      End Get

      ' set mHour value
      Set(ByVal value As Integer)

         If (value >= 0 AndAlso value < 24) Then
            mHour = value
         Else
            mHour = 0
         End If

      End Set

   End Property ' Hour

   ' property Minute
   Public Property Minute() As Integer

      ' return mMinute value
      Get
         Return mMinute
      End Get

      ' set mMinute value
      Set(ByVal value As Integer)

         If (value >= 0 AndAlso value < 60) Then
            mMinute = value
         Else
            mMinute = 0
         End If

      End Set

   End Property ' Minute

   ' property Second
   Public Property Second() As Integer

      ' return mSecond value
      Get
         Return mSecond
      End Get

      ' set mSecond value
      Set(ByVal value As Integer)

         If (value >= 0 AndAlso value < 60) Then
            mSecond = value
         Else
            mSecond = 0
         End If

      End Set

   End Property ' Second

   ' convert String to universal-time format
   Public Function ToUniversalString() As String
      Return String.Format("{0}:{1:D2}:{2:D2}", _
         mHour, mMinute, mSecond)
   End Function ' ToUniversalString

   ' convert to String in standard-time format
   Public Function ToStandardString() As String
      Dim suffix As String = " PM"
      Dim format As String = "{0}:{1:D2}:{2:D2}"
      Dim standardHour As Integer

      ' determine whether time is AM or PM
      If mHour < 12 Then
         suffix = " AM"
      End If

      ' convert from universal-time format to standard-time format
      If (mHour = 12 OrElse mHour = 0) Then
         standardHour = 12
      Else
         standardHour = mHour Mod 12
      End If

      Return String.Format(format, standardHour, mMinute, _
         mSecond) & suffix
   End Function ' ToStandardString

End Class  ' CTime3

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************