' Fig. 8.17: CEmployee3.vb
' Class CEmployee3 uses Shared variable.

Public Class CEmployee3
   Inherits Object

   Private mFirstName As String
   Private mLastName As String

   ' number of objects in memory
   Private Shared mCount As Integer

   ' CEmployee3 constructor
   Public Sub New(ByVal firstNameValue As String, _
      ByVal lastNameValue As String)

      mFirstName = firstNameValue
      mLastName = lastNameValue

      mCount += 1 ' increment shared count of employees
      Console.WriteLine _
         ("Employee object constructor: " & mFirstName & _
         " " & mLastName)
   End Sub ' New

   ' finalizer method decrements Shared count of employees
   Protected Overrides Sub Finalize()
      mCount -= 1 ' decrement mCount, resulting in one fewer object
      Console.WriteLine _
         ("Employee object finalizer: " & mFirstName & _
         " " & mLastName & "; count = " & mCount)
   End Sub ' Finalize

   ' return first name
   Public ReadOnly Property FirstName() As String

      Get
         Return mFirstName
      End Get

   End Property ' FirstName

   ' return last name
   Public ReadOnly Property LastName() As String

      Get
         Return mLastName
      End Get

   End Property ' LastName

   ' property Count
   Public Shared ReadOnly Property Count() As Integer

      Get
         Return mCount
      End Get

   End Property ' Count

End Class ' CEmployee3

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *
' *                                                           *
' * DISCLAIMER: The authors and publisher of this book have   *
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              *
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    *
' *************************************************************
